Installer - Bug #3851

Reports with errors on the puppet master side are not shown as failed
12/11/2013 10:30 AM - Anonymous

Status: Closed

Priority: Normal

Assignee: Dominic Cleal

Category: Foreman modules

Target version: 1.5.1

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1110365 Red Hat JIRA:

Pull request:

Description

If a puppet agent gets an error like "Could not retrieve catalog from remote server: Error 400 on SERVER: Failed to parse template"
or a syntax error on the puppet master, this is correctly shown as

Level "err"

Resource "Puppet”

Message "Could not retrieve catalog..."

when | click in such a report. However, when | browse reports, such reports are marked with 0 "Failed" events. | then have to search
for e.g. "log ~ err" to see if such reports exist.

These Reports should be marked as failed.

Related issues:

Related to Foreman - Bug #2976: Reports page not showing when an Error was re... Duplicate 08/28/2013
Related to Foreman - Bug #8734: Failed puppet report shown as successfull Rejected 12/17/2014
Has duplicate Foreman - Bug #5797: Foreman does not flag catalog retieve fail... Duplicate 05/19/2014
Has duplicate Foreman - Bug #855: some non-empty reports are not in interesti... Duplicate 04/20/2011

Associated revisions

Revision eb7410a3 - 05/12/2014 09:14 PM - Dominic Cleal

fixes #3851 - increment error counter for non-resource Puppet errors

History

#1 - 12/11/2013 01:23 PM - Dominic Cleal

- Related to Bug #2976: Reports page not showing when an Error was returned added

#2 - 12/11/2013 01:24 PM - Dominic Cleal

Is this the same as #2976 do you think? Does the host show the error, but the report metrics don't?

#3 - 12/11/2013 01:45 PM - Anonymous

The host has a green zero and "No changes", so it's not set into error state...

| recall that it worked with Puppet 2.7 and the behaviour changed with puppet 3.x (but | can't recall if it still worked with 2.7 clients against a 3.x
master).

Also, | just was tinnkering around and the error does correctly set the error state, wenn | do a puppet run with "puppet agent --test" on the shell of
such a client, but if the normal 30 minute puppet runs as daemon run into such an error, it does not set the error state.

#4 - 12/11/2013 01:53 PM - Dominic Cleal
The difference between daemon and --test mode might be "usecacheonfailure" which is enabled by default | think and disabled with --test. It might be

in daemon mode that it's falling back to a copy of the old catalog.

#5 - 12/11/2013 02:02 PM - Anonymous

ah, right... if the case of the non-cached catalog | also have the error "err  Puppet  Could not retrieve catalog; skipping run"

#6 - 01/05/2014 10:21 PM - Anonymous
https://projects.theforeman.org/issues/2976

Puppet itself doesn't include these types of errors in it's summary anymore, that seems to be the root cause:

——— !ruby/object:Puppet::Transaction: :Report

metrics:

resources: !ruby/object:Puppet::Util::Metric

name: resources
label: Resources
values:
= = etal
- Total
- 73
- - skipped
- Skipped
-0
- — failed
- Failed
-0
- - failed_to_restart
- "Failed to restart"
-0
- — restarted
- Restarted
-0
— — changed
— Changed
-0
- — out_of_sync
- "Out of sync"
-0
— — scheduled
— Scheduled
-0

The error itself is correctly tagged and gets imported correctly:

logs:
- !ruby/object:Puppet::Util::Log
level: !ruby/sym err
tags:
- err
message: "Could not retrieve catalog from remote server:

Error 400 on SERVER: Could not parse for enviro

nment production: Syntax error at 'mcollective::server::setting'; expected

p:35 on node xxx"
source: Puppet

time: 2014-01-05 22:49:11.379313 +01:

- !ruby/object:Puppet::Util::Log
level: !ruby/sym notice
tags:
- notice
message: "Using cached catalog"
source: Puppet

time: 2014-01-05 22:49:16.229270 +01:

— !ruby/object:Puppet::Util: :Log
level: !ruby/sym notice
tags:
- notice

message: "Finished catalog run in 10.

source: Puppet

time: 2014-01-05 22:49:29.766312 +01:

#7 - 04/30/2014 08:42 PM - Jon McKenzie

00

00

71 seconds"

00

0f 0

This seems to be the relevant epic on the Puppet side: https://tickets.puppetlabs.com/browse/PUP-283

at /etc/puppet/manifests/site.p

Since this seems to have low priority on the Puppet end (some of the relevant issues are targetted for 4.x), is there anything that can be done on the
Foreman side of things? It's a little user unfriendly to see hosts with no activity, that when you click into their reports you see compilation and other

errors.

A simple implementation could be to alter the Foreman report processor to add its own Foreman-internal flag into the report if it detects 'error' log lines
in the report. The Foreman Ul could then pick up on this flag and display it. (Though I'm not sure what the precedent is for altering a report to add

custom data)
https://tickets.puppetlabs.com/browse/PUP-283

#8 - 05/01/2014 07:52 AM - Dominic Cleal

- Project changed from Foreman to Installer

- Category changed from Reporting to Foreman modules
- Status changed from New to Ready For Testing

- Assignee set to Dominic Cleal

- Target version set to 1.8.3

https://github.com/theforeman/puppet-foreman/pull/186

This works on the same principle as some other fixes we make to the counters, which causes Foreman to flag the host as in an error state.

#9 - 05/12/2014 09:53 PM - Dominic Cleal
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset puppet-foreman|commit:eb7410a3787432f417dc13465f25e46353362d91.

#10 - 05/19/2014 05:57 PM - Dominic Cleal

- Has duplicate Bug #5797: Foreman does not flag catalog retieve failures as a puppet failure if the cached catalog runs without issues added

#11 - 06/11/2014 06:19 PM - Dominic Cleal

- translation missing: en.field_release set to 16

#12 - 06/17/2014 01:49 PM - Bryan Kearney
- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1110365

#13 - 09/14/2014 04:55 PM - Anonymous

- Has duplicate Bug #855: some non-empty reports are not in interesting reports added

#14 - 12/17/2014 03:21 AM - Dominic Cleal
- Related to Bug #8734: Failed puppet report shown as successfull added

05/10/2024 3/3


https://github.com/theforeman/puppet-foreman/pull/186
http://www.tcpdf.org

